﻿from field import *
from user import *
from cstime import Time
import clr

clr.AddReference('System')
from System import Guid


class FieldRecord:
    fid = ""
    uid = ""
    start_time: Time
    end_time: Time

    def __init__(self, *args, **kwargs):
        if len(args) == 0:
            pass
        if len(args) == 1:
            field_record = args[0]
            self.fid = field_record.Fid.ToString()
            self.uid = field_record.Uid.ToString()
            print(type(field_record.StartTime))
            self.start_time = Time(field_record.StartTime)
            self.end_time = Time(field_record.EndTime)
        elif len(args) == 4 and isinstance(args[0], User) and isinstance(args[1], Field) and isinstance(args[2],
                                                                                                        Time.struct_time) and isinstance(
            args[3], Time.struct_time):
            user, field, start_time, end_time = args
            self.fid = field.id
            self.uid = user.id
            self.start_time = start_time
            self.end_time = end_time
        else:
            raise ValueError("Invalid arguments for UserFieldRecord initialization")

    def parse_to_csharp_object(self, empty_field_record):
        empty_field_record.Fid = Guid.Parse(self.fid)
        empty_field_record.Uid = Guid.Parse(self.uid)
        empty_field_record.StartTime = self.start_time.struct_time
        empty_field_record.EndTime = self.end_time.struct_time
        return empty_field_record
